; Started May 11 2004 in NASM
; Remade in MASM on August 13 2004
; Remade in FASM on August 18 2004
[BITS 16]
[ORG 7C00h]
start:
jmp begin

LoadMsg	db "Loading RooOs...",0
LoadOk	db "Ok.",13,10
		db "RooOs Kernel Loaded successfully!!!",13,10
		db "Starting RooOs....",13,10,0
;LoadBad	db "Error booting RooOs",13,10
;		db "Press any key to restart",0
Dot		db ".....",0

PModeMsg	db "Successfully started 32-bit protected mode",0
Err_Div0	db "Integer divide by zero error",0	;x = 26 , y = 13*25

begin:

xor ax,ax
mov ds,ax

mov si,LoadMsg
call PrintStr

mov ah,02h
mov al,5
mov ch,0
mov cl,2
mov dh,0
mov dl,0
xor bx,bx
mov es,bx
mov bx,1000h
int 13h

mov dx,03F2h
mov al,0Ch
out dx,al

call Enable_A20

;mov ax,0003h
;int 10h

;jmp 1000h:00h

;mov si,LoadOk
;call PrintStr
jmp startp

PrintStr:
	mov ah,0eh
	stringloop:
	lodsb
	test al,al
	je endstring
	int 10h
	jmp stringloop
endstring:
	ret

startp:
cli
xor ax,ax
mov ds,ax
lgdt [gdt_desc]
mov eax,cr0
or eax,1
mov cr0,eax
jmp 08h:pmode

[BITS 32]
pmode:
	mov ax,10h	; Mul by 8 number of segment after null seg
	mov ds,ax
	mov es,ax
	mov ax,18h	; Stack Segment
	mov ss,ax
	mov esp,090000h	; set stack at a good place

	jmp 08h:01000h ;jmp to the kernel
	mov byte[ds:0B8000h],'A'

Enable_A20:
	cli
	call Empty8024
	in al,0D1h
	out 64h,al
	call Empty8024
	in al, 0DFh
	out 60h,al
	sti
	ret

Empty8024:
	in al, 64h
	test al,1
	jz empty1
	in al, 060h
	jmp Empty8024
	empty1:
	test al,2
	jnz Empty8024
	retn 4

gdt:
gdt_null:
	dd 0		; Null Descriptor
	dd 0
gdt_code:
	dw 0FFFFh	; limit
	dw 0		; base
	db 0		; base mid
	db 10011010b; Flags		Bits Reverse
	db 11001111b; Attributes	    ,,
	db 0		; Base low
gdt_data:
	dw 0FFFFh
	dw 0
	db 0
	db 10010010b
	db 11001111b
	db 0
gdt_stack:
	dw 0FFFFh
	dw 0
	db 0
	db 10010010b
	db 11001111b
	db 0
;gdt_video:
;	dw 0FFFFh
;	dw 0
;	db 0
;	db 10010010b
;	db 11001111b
;	db 0
gdt_end:

gdt_desc:	dw gdt_end-gdt-1
		dd gdt

times 510-($-$$) db 0
db 055h,0AAh
